--- old/usr/src/uts/common/io/comstar/port/qlt/qlt.c	Mon Aug  5 17:27:33 2019
+++ new/usr/src/uts/common/io/comstar/port/qlt/qlt.c	Mon Aug  5 17:27:33 2019
@@ -2132,16 +3227,27 @@
  * updates the req in ptr to fw. Assumes that req lock is held.
  */
 void
-qlt_submit_req_entries(qlt_state_t *qlt, uint32_t n)
+qlt_submit_req_entries(qlt_state_t *qlt, uint32_t n, uint16_t qi)
 {
+
 	ASSERT(n >= 1);
-	qlt->req_ndx_to_fw += n;
-	qlt->req_ndx_to_fw &= REQUEST_QUEUE_ENTRIES - 1;
-	qlt->req_available -= n;
-	REG_WR32(qlt, REG_REQ_IN_PTR, qlt->req_ndx_to_fw);
-}
 
+	qlt->mq_req[qi].mq_ndx_to_fw += n;
+	if (qi != 0) {
+		qlt->mq_req[qi].mq_ndx_to_fw &= REQUEST_QUEUE_MQ_ENTRIES - 1;
+	} else {
+		qlt->mq_req[qi].mq_ndx_to_fw &= REQUEST_QUEUE_ENTRIES - 1;
+	}
+	qlt->mq_req[qi].mq_available -= n;
 
+	if (qlt->qlt_mq_enabled) {
+		MQBAR_WR32(qlt, (qi * MQBAR_REG_OFFSET) + MQBAR_REQ_IN,
+		    qlt->mq_req[qi].mq_ndx_to_fw);
+	} else {
+		REG_WR32(qlt, REG_REQ_IN_PTR, qlt->mq_req[0].mq_ndx_to_fw);
+	}
+}
+
 /*
  * Return a pointer to n entries in the priority request queue. Assumes that
  * priority request queue lock is held. Does a very short busy wait if
@@ -2218,6 +3324,7 @@
 
 	/* XXX: Switch off LEDs */
 
+	qlt->qlt_intr_enabled = 0;
 	/* Disable Interrupts */
 	REG_WR32(qlt, REG_INTR_CTRL, 0);
 	(void) REG_RD32(qlt, REG_INTR_CTRL);
@@ -2234,6 +3341,24 @@
 			return (QLT_DMA_STUCK);
 	}
 
+	/* need to ensure no one accesses the hw during the reset 100us */
+	if ((qlt->qlt_83xx_chip) || (qlt->qlt_27xx_chip)) {
+		mutex_enter(&qlt->mbox_lock);
+		if (qlt->qlt_mq_enabled == 1) {
+			int i;
+
+			for (i = 1; i < qlt->qlt_queue_cnt; i++) {
+				mutex_enter(&qlt->mq_req[i].mq_lock);
+			}
+		}
+		mutex_enter(&qlt->mq_req[0].mq_lock);
+		/*
+		 * We need to give time for other threads to finsh their
+		 * interupts (or we need another lock)
+		 */
+		drv_usecwait(40);
+	}
+
 	/* Reset the Chip */
 	REG_WR32(qlt, REG_CTRL_STATUS,
 	    DMA_SHUTDOWN_CTRL | PCI_X_XFER_CTRL | CHIP_SOFT_RESET);
@@ -2242,6 +3367,18 @@
 
 	drv_usecwait(100);
 
+	if ((qlt->qlt_83xx_chip) || (qlt->qlt_27xx_chip)) {
+		mutex_exit(&qlt->mq_req[0].mq_lock);
+		if (qlt->qlt_mq_enabled == 1) {
+			int i;
+
+			for (i = 1; i < qlt->qlt_queue_cnt; i++) {
+				mutex_exit(&qlt->mq_req[i].mq_lock);
+			}
+		}
+		mutex_exit(&qlt->mbox_lock);
+	}
+
 	/* Wait for ROM firmware to initialize (0x0000) in mailbox 0 */
 	cntr = 0;
 	while (REG_RD16(qlt, REG_MBOX(0)) != 0) {
@@ -2256,6 +3393,7 @@
 
 	return (QLT_SUCCESS);
 }
+
 /*
  * - Should not be called from Interrupt.
  * - A very hardware specific function. Does not touch driver state.
@@ -2292,6 +3430,23 @@
 			    qlt->fw_length02, qlt->fw_addr02);
 		}
 		start_addr = qlt->fw_addr01;
+	} else if (qlt->qlt_27xx_chip) {
+		(void) qlt_27xx_get_dmp_template(qlt);
+		ret = qlt_load_risc_ram(qlt, fw2700_code01,
+		    fw2700_length01, fw2700_addr01);
+		if (ret == QLT_SUCCESS) {
+			ret = qlt_load_risc_ram(qlt, fw2700_code02,
+			    fw2700_length02, fw2700_addr02);
+		}
+		start_addr = fw2700_addr01;
+	} else if (qlt->qlt_83xx_chip) {
+		ret = qlt_load_risc_ram(qlt, fw8300fc_code01,
+		    fw8300fc_length01, fw8300fc_addr01);
+		if (ret == QLT_SUCCESS) {
+			ret = qlt_load_risc_ram(qlt, fw8300fc_code02,
+			    fw8300fc_length02, fw8300fc_addr02);
+		}
+		start_addr = fw8300fc_addr01;
 	} else if (qlt->qlt_81xx_chip) {
 		ret = qlt_load_risc_ram(qlt, fw8100_code01, fw8100_length01,
 		    fw8100_addr01);
@@ -2338,12 +3493,29 @@
 	REG_WR16(qlt, REG_MBOX(1), MSW(start_addr));
 	REG_WR16(qlt, REG_MBOX(2), LSW(start_addr));
 	REG_WR16(qlt, REG_MBOX(3), 0);
-	REG_WR16(qlt, REG_MBOX(4), 1);	/* 25xx enable additional credits */
+#ifdef EXTRA_CREDIT
+	/* enable extra credits (reduces available buffers) */
+	if ((qlt->qlt_25xx_chip) || (qlt->qlt_81xx_chip) ||
+	    (qlt->qlt_83xx_chip) || (qlt->qlt_27xx_chip)) {
+		REG_WR16(qlt, REG_MBOX(4), 1);
+	} else {
+		REG_WR16(qlt, REG_MBOX(4), 0);
+	}
+#else
+	REG_WR16(qlt, REG_MBOX(4), 0);
+#endif
 	ret = qlt_raw_mailbox_command(qlt);
 	REG_WR32(qlt, REG_HCCR, HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
 	if (ret != QLT_SUCCESS) {
 		EL(qlt, "qlt_raw_mailbox_command=2h status=%llxh\n", ret);
 		return (ret);
+	} else {
+		if (qlt->qlt_27xx_chip) {
+			qlt->qlt_27xx_speed = (uint32_t)
+			    (REG_RD16(qlt, REG_MBOX(3)) << 16 |
+			    REG_RD16(qlt, REG_MBOX(2)));
+
+		}
 	}
 
 	/* Get revisions (About Firmware) */
@@ -2361,6 +3533,25 @@
 		return (ret);
 	}
 
+	if (qlt->qlt_27xx_chip) {
+		qlt->fw_ext_memory_end = SHORT_TO_LONG(
+		    REG_RD16(qlt, REG_MBOX(4)),
+		    REG_RD16(qlt, REG_MBOX(5)));
+		qlt->fw_shared_ram_start = SHORT_TO_LONG(
+		    REG_RD16(qlt, REG_MBOX(18)),
+		    REG_RD16(qlt, REG_MBOX(19)));
+		qlt->fw_shared_ram_end = SHORT_TO_LONG(
+		    REG_RD16(qlt, REG_MBOX(20)),
+		    REG_RD16(qlt, REG_MBOX(21)));
+		qlt->fw_ddr_ram_start = SHORT_TO_LONG(
+		    REG_RD16(qlt, REG_MBOX(22)),
+		    REG_RD16(qlt, REG_MBOX(23)));
+		qlt->fw_ddr_ram_end = SHORT_TO_LONG(
+		    REG_RD16(qlt, REG_MBOX(24)),
+		    REG_RD16(qlt, REG_MBOX(25)));
+	}
+
+
 	return (QLT_SUCCESS);
 }
 
@@ -2369,7 +3560,7 @@
  */
 static fct_status_t
 qlt_load_risc_ram(qlt_state_t *qlt, uint32_t *host_addr,
-				uint32_t word_count, uint32_t risc_addr)
+    uint32_t word_count, uint32_t risc_addr)
 {
 	uint32_t words_sent = 0;
 	uint32_t words_being_sent;
@@ -2407,6 +3598,7 @@
 		}
 		words_sent += words_being_sent;
 	}
+	EL(qlt, "qlt_raw_mailbox_command=0Bh, LOAD_RAM_EXTENDED complete\n");
 	return (QLT_SUCCESS);
 }
 
@@ -2418,7 +3610,7 @@
  * get back a mailbox completion from firmware.
  * ---DOES NOT CLEAR INTERRUPT---
  * Used only from the code path originating from
- * qlt_reset_chip_and_download_fw()
+ * qlt_reset_chip()
  */
 static fct_status_t
 qlt_raw_mailbox_command(qlt_state_t *qlt)
@@ -2425,11 +3617,16 @@
 {
 	int cntr = 0;
 	uint32_t status;
+	fct_local_port_t *port = qlt->qlt_port;
 
 	REG_WR32(qlt, REG_HCCR, HCCR_CMD(SET_HOST_TO_RISC_INTR));
+retry_raw:;
 	while ((REG_RD32(qlt, REG_INTR_STATUS) & RISC_PCI_INTR_REQUEST) == 0) {
 		cntr++;
-		if (cntr == 100) {
+		if (cntr == 3000) {
+			EL(qlt, "polling exhausted, dump fw now..\n");
+			(void) qlt_firmware_dump(port,
+			    (stmf_state_change_info_t *)NULL);
 			return (QLT_MAILBOX_STUCK);
 		}
 		delay(drv_usectohz(10000));
@@ -2444,9 +3641,40 @@
 		if (mbox0 == QLT_MBX_CMD_SUCCESS) {
 			return (QLT_SUCCESS);
 		} else {
+			EL(qlt, "mbx cmd failed, dump fw now..\n");
+			(void) qlt_firmware_dump(port,
+			    (stmf_state_change_info_t *)NULL);
 			return (QLT_MBOX_FAILED | mbox0);
 		}
+	} else if (status == ASYNC_EVENT) {
+		uint16_t mbox0, mbox1, mbox2, mbox3;
+		uint16_t mbox4, mbox5, mbox6, mbox7;
+
+		mbox0 = REG_RD16(qlt, REG_MBOX(0));
+		mbox1 = REG_RD16(qlt, REG_MBOX(1));
+		mbox2 = REG_RD16(qlt, REG_MBOX(2));
+		mbox3 = REG_RD16(qlt, REG_MBOX(3));
+		mbox4 = REG_RD16(qlt, REG_MBOX(4));
+		mbox5 = REG_RD16(qlt, REG_MBOX(5));
+		mbox6 = REG_RD16(qlt, REG_MBOX(6));
+		mbox7 = REG_RD16(qlt, REG_MBOX(7));
+
+		cmn_err(CE_NOTE, "!qlt(%d): Async event %x mb1=%x mb2=%x"
+		    "mb3=%x mb4=%x mb5=%x mb6=%x mb7=%x",
+		    qlt->instance, mbox0, mbox1, mbox2, mbox3,
+		    mbox4, mbox5, mbox6, mbox7);
+		if (mbox0 == 0x8002) {
+			(void) qlt_firmware_dump(port,
+			    (stmf_state_change_info_t *)NULL);
+			return (QLT_UNEXPECTED_RESPONSE);
+		} else {
+			REG_WR32(qlt,
+			    REG_HCCR, HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
+			cntr = 0;
+			goto retry_raw;
+		}
 	}
+
 	/* This is unexpected, dump a message */
 	cmn_err(CE_WARN, "qlt(%d): Unexpect intr status %llx",
 	    ddi_get_instance(qlt->dip), (unsigned long long)status);
@@ -2501,7 +3729,7 @@
 {
 	int	retries;
 	int	i;
-	char	info[QLT_INFO_LEN];
+	char	info[80];
 
 	if (curthread->t_flag & T_INTR_THREAD) {
 		ASSERT(0);
@@ -2508,6 +3736,9 @@
 		return (QLT_MBOX_FAILED);
 	}
 
+	EL(qlt, "mailbox:[0]=%xh [1]=%xh\n",
+	    mcp->to_fw[0], mcp->to_fw[1]);
+
 	mutex_enter(&qlt->mbox_lock);
 	/* See if mailboxes are still uninitialized */
 	if (qlt->mbox_io_state == MBOX_STATE_UNKNOWN) {
@@ -2541,9 +3772,9 @@
 	/* Wait for mailbox command completion */
 	if (cv_timedwait(&qlt->mbox_cv, &qlt->mbox_lock, ddi_get_lbolt()
 	    + drv_usectohz(MBOX_TIMEOUT)) < 0) {
-		(void) snprintf(info, sizeof (info),
-		    "qlt_mailbox_command: qlt-%p, "
+		(void) snprintf(info, 80, "qlt_mailbox_command: qlt-%p, "
 		    "cmd-0x%02X timed out", (void *)qlt, qlt->mcp->to_fw[0]);
+		info[79] = 0;
 		qlt->mcp = NULL;
 		qlt->mbox_io_state = MBOX_STATE_UNKNOWN;
 		mutex_exit(&qlt->mbox_lock);
@@ -2571,17 +3802,434 @@
 	/* Mailboxes are already loaded by interrupt routine */
 	qlt->mbox_io_state = MBOX_STATE_READY;
 	mutex_exit(&qlt->mbox_lock);
-	if (mcp->from_fw[0] != QLT_MBX_CMD_SUCCESS)
+	if (mcp->from_fw[0] != QLT_MBX_CMD_SUCCESS) {
+		EL(qlt, "fw[0] = %xh\n", mcp->from_fw[0]);
+		if ((mcp->from_fw[0] != 0x4005) &&
+		    (mcp->from_fw[1] != 0x7)) {
+			(void) qlt_firmware_dump(qlt->qlt_port,
+			    (stmf_state_change_info_t *)NULL);
+		}
 		return (QLT_MBOX_FAILED | mcp->from_fw[0]);
+	}
 
 	return (QLT_SUCCESS);
 }
 
+clock_t qlt_next_invalid_msg = 0;
+int qlt_invalid_idx_cnt = 0;
+
 /*
  * **SHOULD ONLY BE CALLED FROM INTERRUPT CONTEXT. DO NOT CALL ELSEWHERE**
  */
 /* ARGSUSED */
 static uint_t
+qlt_msix_resp_handler(caddr_t arg, caddr_t arg2)
+{
+	qlt_state_t	*qlt = (qlt_state_t *)arg;
+	uint32_t	risc_status;
+	uint16_t 	qi = 0;
+	clock_t		now;
+
+	risc_status = REG_RD32(qlt, REG_RISC_STATUS);
+	if (qlt->qlt_mq_enabled) {
+		/* XXX: */
+		/* qi = (uint16_t)((unsigned long)arg2); */
+		qi = (uint16_t)(risc_status >> 16);
+		if (qi >= MQ_MAX_QUEUES) {
+			/*
+			 * Two customers have reported panics in the call to
+			 * mutex_enter below. Analysis showed the address passed
+			 * in could only occur if 'qi' had a value of 0x4000.
+			 * We'll ignore the upper bits and see if an index which
+			 * at least within the range of possible produces some
+			 * sane results.
+			 */
+			now = ddi_get_lbolt();
+			if (now > qlt_next_invalid_msg) {
+				/*
+				 * Since this issue has never been seen in the
+				 * lab it's unknown if once this bit gets set
+				 * does it remain until the next hardware reset?
+				 * If so, we don't want to flood the message
+				 * buffer or make it difficult to reboot the
+				 * system.
+				 */
+				qlt_next_invalid_msg = now +
+				    drv_usectohz(MICROSEC * 10);
+				cmn_err(CE_NOTE, "QLT: hardware reporting "
+				    "invalid index: 0x%x", qi);
+			}
+			qi &= MQ_MAX_QUEUES_MASK;
+			qlt_invalid_idx_cnt++;
+		}
+
+		mutex_enter(&qlt->mq_resp[qi].mq_lock);
+		if (!qlt->qlt_intr_enabled) {
+			/*
+			 * No further interrupt since intr disabled.
+			 */
+			REG_WR32(qlt, REG_HCCR,
+			    HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
+			mutex_exit(&qlt->mq_resp[qi].mq_lock);
+			return (DDI_INTR_UNCLAIMED);
+		}
+
+		qlt->mq_resp[qi].mq_ndx_from_fw =
+		    (uint16_t)MQBAR_RD32(qlt,
+		    (qi * MQBAR_REG_OFFSET) + MQBAR_RESP_IN);
+
+		qlt_handle_resp_queue_update(qlt, qi);
+		mutex_exit(&qlt->mq_resp[qi].mq_lock);
+	} else {
+		mutex_enter(&qlt->intr_lock);
+		if (!qlt->qlt_intr_enabled) {
+			/*
+			 * No further interrupt since intr disabled.
+			 */
+			REG_WR32(qlt, REG_HCCR,
+			    HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
+			mutex_exit(&qlt->intr_lock);
+			return (DDI_INTR_UNCLAIMED);
+		}
+
+		qlt->atio_ndx_from_fw =
+		    (uint16_t)REG_RD32(qlt, REG_ATIO_IN_PTR);
+		qlt_handle_atio_queue_update(qlt);
+
+		qlt->mq_resp[qi].mq_ndx_from_fw = risc_status >> 16;
+		qlt_handle_resp_queue_update(qlt, qi);
+		mutex_exit(&qlt->intr_lock);
+	}
+
+	if (risc_status & BIT_15) {
+		REG_WR32(qlt, REG_HCCR, HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
+	}
+	return (DDI_INTR_CLAIMED);
+}
+
+
+/*
+ * **SHOULD ONLY BE CALLED FROM INTERRUPT CONTEXT. DO NOT CALL ELSEWHERE**
+ */
+/* ARGSUSED */
+static uint_t
+qlt_msix_default_handler(caddr_t arg, caddr_t arg2)
+{
+	qlt_state_t	*qlt = (qlt_state_t *)arg;
+	uint32_t	risc_status, intr_type;
+	int		i;
+	char		info[80];
+
+	risc_status = REG_RD32(qlt, REG_RISC_STATUS);
+	if (!mutex_tryenter(&qlt->intr_lock)) {
+		/*
+		 * Normally we will always get this lock. If tryenter is
+		 * failing then it means that driver is trying to do
+		 * some cleanup and is masking the intr but some intr
+		 * has sneaked in between. See if our device has generated
+		 * this intr. If so then wait a bit and return claimed.
+		 * If not then return claimed if this is the 1st instance
+		 * of a interrupt after driver has grabbed the lock.
+		 */
+		if ((risc_status & BIT_15) == 0) {
+			return (DDI_INTR_UNCLAIMED);
+		} else {
+			/* try again */
+			drv_usecwait(10);
+			if (!mutex_tryenter(&qlt->intr_lock)) {
+				/* really bad! */
+				return (DDI_INTR_CLAIMED);
+			}
+		}
+	}
+	if (((risc_status & BIT_15) == 0) ||
+	    (qlt->qlt_intr_enabled == 0)) {
+		/*
+		 * This might be a pure coincedence that we are operating
+		 * in a interrupt disabled mode and another device
+		 * sharing the interrupt line has generated an interrupt
+		 * while an interrupt from our device might be pending. Just
+		 * ignore it and let the code handling the interrupt
+		 * disabled mode handle it.
+		 */
+		mutex_exit(&qlt->intr_lock);
+		return (DDI_INTR_UNCLAIMED);
+	}
+
+	/* REG_WR32(qlt, REG_INTR_CTRL, 0); */
+
+	/* check for risc pause - unlikely */
+	if (risc_status & BIT_8) {
+		uint32_t hccsr;
+
+		hccsr = REG_RD32(qlt, REG_HCCR);
+		EL(qlt, "Risc Pause status=%xh hccsr=%x\n",
+		    risc_status, hccsr);
+		cmn_err(CE_WARN, "qlt(%d): Risc Pause %08x hccsr:%x",
+		    qlt->instance, risc_status, hccsr);
+		(void) snprintf(info, 80, "Risc Pause %08x hccsr:%x",
+		    risc_status, hccsr);
+		info[79] = 0;
+		(void) fct_port_shutdown(qlt->qlt_port,
+		    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET |
+		    STMF_RFLAG_COLLECT_DEBUG_DUMP, info);
+	}
+
+	/* check most likely types first */
+	intr_type = risc_status & 0xff;
+	if (intr_type == 0x1D) {
+		qlt->atio_ndx_from_fw =
+		    (uint16_t)REG_RD32(qlt, REG_ATIO_IN_PTR);
+		qlt_handle_atio_queue_update(qlt);
+		qlt->mq_resp[0].mq_ndx_from_fw = risc_status >> 16;
+		qlt_handle_resp_queue_update(qlt, 0);
+		REG_WR32(qlt, REG_HCCR, HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
+	} else if (intr_type == 0x1C) {
+		qlt->atio_ndx_from_fw = (uint16_t)(risc_status >> 16);
+		qlt_handle_atio_queue_update(qlt);
+		REG_WR32(qlt, REG_HCCR, HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
+	} else if (intr_type == 0x1E) {
+		/* 83xx */
+		qlt->atio_ndx_from_fw =
+		    (uint16_t)MQBAR_RD32(qlt, MQBAR_ATIO_IN);
+		qlt_handle_atio_queue_update(qlt);
+		REG_WR32(qlt, REG_HCCR, HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
+	} else if (intr_type == 0x13) {
+		uint16_t qi;
+
+		qlt->atio_ndx_from_fw =
+		    (uint16_t)REG_RD32(qlt, REG_ATIO_IN_PTR);
+		qlt_handle_atio_queue_update(qlt);
+
+		if (qlt->qlt_mq_enabled) {
+			qi = (uint16_t)(risc_status >> 16);
+			qlt->mq_resp[qi].mq_ndx_from_fw =
+			    (uint16_t)MQBAR_RD32(qlt,
+			    (qi * MQBAR_REG_OFFSET) + MQBAR_RESP_IN);
+			/* FIX THIS to be optional */
+			REG_WR32(qlt, REG_HCCR,
+			    HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
+		} else {
+			qi = 0;
+			REG_WR32(qlt, REG_HCCR,
+			    HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
+			qlt->mq_resp[qi].mq_ndx_from_fw = risc_status >> 16;
+		}
+		qlt_handle_resp_queue_update(qlt, qi);
+
+	} else if (intr_type == 0x14) {
+		uint16_t qi = (uint16_t)(risc_status >> 16);
+
+		if ((qlt->qlt_83xx_chip) || (qlt->qlt_27xx_chip)) {
+			qlt->atio_ndx_from_fw =
+			    (uint16_t)MQBAR_RD32(qlt, MQBAR_ATIO_IN);
+		} else {
+			qlt->atio_ndx_from_fw = (uint16_t)
+			    REG_RD32(qlt, REG_ATIO_IN_PTR);
+		}
+		qlt_handle_atio_queue_update(qlt);
+
+		qlt->mq_resp[qi].mq_ndx_from_fw =
+		    (uint16_t)MQBAR_RD32(qlt,
+		    (qi * MQBAR_REG_OFFSET) + MQBAR_RESP_IN);
+		qlt_handle_resp_queue_update(qlt, qi);
+
+		REG_WR32(qlt, REG_HCCR, HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
+
+	} else if (intr_type == 0x12) {
+		uint16_t code, mbox1, mbox2, mbox3, mbox4, mbox5, mbox6;
+
+		REG_WR32(qlt, REG_INTR_CTRL, 0);
+
+		code = (uint16_t)(risc_status >> 16);
+		mbox1 = REG_RD16(qlt, REG_MBOX(1));
+		mbox2 = REG_RD16(qlt, REG_MBOX(2));
+		mbox3 = REG_RD16(qlt, REG_MBOX(3));
+		mbox4 = REG_RD16(qlt, REG_MBOX(4));
+		mbox5 = REG_RD16(qlt, REG_MBOX(5));
+		mbox6 = REG_RD16(qlt, REG_MBOX(6));
+
+		REG_WR32(qlt, REG_HCCR, HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
+		EL(qlt, "Async event: %x mb1=%x mb2=%x,"
+		    " mb3=%x, mb4=%x, mb5=%x, mb6=%x", code, mbox1, mbox2,
+		    mbox3, mbox4, mbox5, mbox6);
+		stmf_trace(qlt->qlt_port_alias, "Async event: %x mb1=%x mb2=%x,"
+		    " mb3=%x, mb4=%x, mb5=%x, mb6=%x", code, mbox1, mbox2,
+		    mbox3, mbox4, mbox5, mbox6);
+		cmn_err(CE_NOTE, "!qlt(%d): Async event %x mb1=%x mb2=%x,"
+		    " mb3=%x, mb4=%x,  mb5=%x, mb6=%x", qlt->instance, code,
+		    mbox1, mbox2, mbox3, mbox4, mbox5, mbox6);
+
+		if ((code == 0x8030) || (code == 0x8010) || (code == 0x8013)) {
+			if (qlt->qlt_link_up) {
+				fct_handle_event(qlt->qlt_port,
+				    FCT_EVENT_LINK_RESET, 0, 0);
+			}
+		} else if (code == 0x8012) {
+			qlt->qlt_link_up = 0;
+			fct_handle_event(qlt->qlt_port, FCT_EVENT_LINK_DOWN,
+			    0, 0);
+		} else if (code == 0x8014) {
+			if (mbox1 == 0xffff) { /* global event */
+				uint8_t reason_code;
+
+				reason_code = (uint8_t)(mbox3 >> 8);
+
+				switch (reason_code) {
+				case 0x1d: /* FIP Clear Virtual Link received */
+				case 0x1a: /* received FLOGO */
+				case 0x1c: /* FCF configuration changed */
+				case 0x1e: /* FKA timeout */
+					if (mbox2 == 7) {
+						qlt->qlt_link_up = 0;
+						fct_handle_event(qlt->qlt_port,
+						    FCT_EVENT_LINK_DOWN, 0, 0);
+					}
+					break;
+				case 0x12:
+					if (mbox2 == 4) {
+						qlt->qlt_link_up = 1;
+						fct_handle_event(qlt->qlt_port,
+						    FCT_EVENT_LINK_UP, 0, 0);
+						stmf_trace(qlt->qlt_port_alias,
+						    "SNS login and SCR done");
+					}
+					break;
+				case 0:
+					if ((mbox2 == 6) &&
+					    (!qlt->qlt_link_up)) {
+						qlt->qlt_link_up = 1;
+						fct_handle_event(qlt->qlt_port,
+						    FCT_EVENT_LINK_UP, 0, 0);
+						stmf_trace(qlt->qlt_port_alias,
+						    "Link reinitialised");
+					}
+					break;
+				default:
+					stmf_trace(qlt->qlt_port_alias,
+					    "AEN ignored");
+					break;
+				}
+			}
+		} else if (code == 0x8011) {
+			switch (mbox1) {
+			case 0: qlt->link_speed = PORT_SPEED_1G;
+				break;
+			case 1: qlt->link_speed = PORT_SPEED_2G;
+				break;
+			case 3: qlt->link_speed = PORT_SPEED_4G;
+				break;
+			case 4: qlt->link_speed = PORT_SPEED_8G;
+				break;
+			case 5: qlt->link_speed = PORT_SPEED_16G;
+				break;
+			case 0x13: qlt->link_speed = PORT_SPEED_10G;
+				break;
+			default:
+				qlt->link_speed = PORT_SPEED_UNKNOWN;
+			}
+			qlt->qlt_link_up = 1;
+			fct_handle_event(qlt->qlt_port, FCT_EVENT_LINK_UP,
+			    0, 0);
+		} else if ((code == 0x8002) || (code == 0x8003) ||
+		    (code == 0x8004) || (code == 0x8005)) {
+			(void) snprintf(info, 80,
+			    "Got %04x, mb1=%x mb2=%x mb5=%x mb6=%x",
+			    code, mbox1, mbox2, mbox5, mbox6);
+			info[79] = 0;
+			(void) fct_port_shutdown(qlt->qlt_port,
+			    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET |
+			    STMF_RFLAG_COLLECT_DEBUG_DUMP, info);
+		} else if (code == 0x800F) {
+			(void) snprintf(info, 80,
+			    "Got 800F, mb1=%x mb2=%x mb3=%x",
+			    mbox1, mbox2, mbox3);
+
+			if (mbox1 != 1) {
+				/* issue "verify fw" */
+				qlt_verify_fw(qlt);
+			}
+		} else if (code == 0x8101) {
+			(void) snprintf(info, 80,
+			    "IDC Req Rcvd:%04x, mb1=%x mb2=%x mb3=%x",
+			    code, mbox1, mbox2, mbox3);
+			info[79] = 0;
+
+			/* check if "ACK" is required (timeout != 0) */
+			if (mbox1 & 0x0f00) {
+				caddr_t	req;
+
+				/*
+				 * Ack the request (queue work to do it?)
+				 * using a mailbox iocb
+				 * (Only Queue #0 allowed)
+				 */
+				mutex_enter(&qlt->mq_req[0].mq_lock);
+				req = qlt_get_req_entries(qlt, 1, 0);
+				if (req) {
+					bzero(req, IOCB_SIZE);
+					req[0] = 0x39; req[1] = 1;
+					QMEM_WR16(qlt, req+8, 0x101);
+					QMEM_WR16(qlt, req+10, mbox1);
+					QMEM_WR16(qlt, req+12, mbox2);
+					QMEM_WR16(qlt, req+14, mbox3);
+					QMEM_WR16(qlt, req+16, mbox4);
+					QMEM_WR16(qlt, req+18, mbox5);
+					QMEM_WR16(qlt, req+20, mbox6);
+					qlt_submit_req_entries(qlt, 1, 0);
+				} else {
+					(void) snprintf(info, 80,
+					    "IDC ACK failed");
+					info[79] = 0;
+				}
+				mutex_exit(&qlt->mq_req[0].mq_lock);
+			}
+		} else {
+			stmf_trace(qlt->qlt_port_alias,
+			    "Async event: 0x%x ignored",
+			    code);
+		}
+		REG_WR32(qlt, REG_INTR_CTRL, ENABLE_RISC_INTR);
+	} else if ((intr_type == 0x10) || (intr_type == 0x11)) {
+		/* Handle mailbox completion */
+		mutex_enter(&qlt->mbox_lock);
+		if (qlt->mbox_io_state != MBOX_STATE_CMD_RUNNING) {
+			cmn_err(CE_WARN, "qlt(%d): mailbox completion received"
+			    " when driver wasn't waiting for it %d",
+			    qlt->instance, qlt->mbox_io_state);
+		} else {
+			for (i = 0; i < MAX_MBOXES; i++) {
+				if (qlt->mcp->from_fw_mask &
+				    (((uint32_t)1) << i)) {
+					qlt->mcp->from_fw[i] =
+					    REG_RD16(qlt, REG_MBOX(i));
+				}
+			}
+			qlt->mbox_io_state = MBOX_STATE_CMD_DONE;
+		}
+		REG_WR32(qlt, REG_HCCR, HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
+		cv_broadcast(&qlt->mbox_cv);
+		mutex_exit(&qlt->mbox_lock);
+	} else {
+		cmn_err(CE_WARN, "qlt(%d): Unknown intr type 0x%x",
+		    qlt->instance, intr_type);
+		stmf_trace(qlt->qlt_port_alias,
+		    "%s: Unknown intr type 0x%x [%x]",
+		    __func__, intr_type, risc_status);
+		REG_WR32(qlt, REG_HCCR, HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
+	}
+
+	/* REG_WR32(qlt, REG_INTR_CTRL, ENABLE_RISC_INTR); */
+	mutex_exit(&qlt->intr_lock);
+
+	return (DDI_INTR_CLAIMED);
+}
+
+/*
+ * **SHOULD ONLY BE CALLED FROM INTERRUPT CONTEXT. DO NOT CALL ELSEWHERE**
+ */
+/* ARGSUSED */
+static uint_t
 qlt_isr(caddr_t arg, caddr_t arg2)
 {
 	qlt_state_t	*qlt = (qlt_state_t *)arg;
@@ -2588,7 +4236,7 @@
 	uint32_t	risc_status, intr_type;
 	int		i;
 	int		intr_loop_count;
-	char		info[QLT_INFO_LEN];
+	char		info[80];
 
 	risc_status = REG_RD32(qlt, REG_RISC_STATUS);
 	if (!mutex_tryenter(&qlt->intr_lock)) {
@@ -2626,7 +4274,7 @@
 	}
 
 	/*
-	 * XXX take care for MSI case. disable intrs
+	 * XXX take care for MSI-X case. disable intrs
 	 * Its gonna be complicated because of the max iterations.
 	 * as hba will have posted the intr which did not go on PCI
 	 * but we did not service it either because of max iterations.
@@ -2643,8 +4291,8 @@
 		EL(qlt, "Risc Pause status=%xh\n", risc_status);
 		cmn_err(CE_WARN, "qlt(%d): Risc Pause %08x",
 		    qlt->instance, risc_status);
-		(void) snprintf(info, sizeof (info), "Risc Pause %08x",
-		    risc_status);
+		(void) snprintf(info, 80, "Risc Pause %08x", risc_status);
+		info[79] = 0;
 		(void) fct_port_shutdown(qlt->qlt_port,
 		    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET |
 		    STMF_RFLAG_COLLECT_DEBUG_DUMP, info);
@@ -2653,20 +4301,73 @@
 	/* First check for high performance path */
 	intr_type = risc_status & 0xff;
 	if (intr_type == 0x1D) {
-		qlt->atio_ndx_from_fw = (uint16_t)
-		    REG_RD32(qlt, REG_ATIO_IN_PTR);
-		REG_WR32(qlt, REG_HCCR, HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
-		qlt->resp_ndx_from_fw = risc_status >> 16;
+
+		/* process the atio queue first */
+		qlt->atio_ndx_from_fw =
+		    (uint16_t)REG_RD32(qlt, REG_ATIO_IN_PTR);
 		qlt_handle_atio_queue_update(qlt);
-		qlt_handle_resp_queue_update(qlt);
+
+		/* process the response queue next */
+		qlt->mq_resp[0].mq_ndx_from_fw =
+		    (uint16_t)REG_RD32(qlt, REG_RESP_IN_PTR);
+		qlt_handle_resp_queue_update(qlt, 0);
+		REG_WR32(qlt, REG_HCCR, HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
+
 	} else if (intr_type == 0x1C) {
 		REG_WR32(qlt, REG_HCCR, HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
 		qlt->atio_ndx_from_fw = (uint16_t)(risc_status >> 16);
 		qlt_handle_atio_queue_update(qlt);
+	} else if (intr_type == 0x1E) {
+		/* 83xx Atio Queue update */
+		qlt->atio_ndx_from_fw =
+		    (uint16_t)MQBAR_RD32(qlt, MQBAR_ATIO_IN);
+		qlt_handle_atio_queue_update(qlt);
+		REG_WR32(qlt, REG_HCCR, HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
 	} else if (intr_type == 0x13) {
+		uint16_t qi;
+
+		qlt->atio_ndx_from_fw =
+		    (uint16_t)REG_RD32(qlt, REG_ATIO_IN_PTR);
+		qlt_handle_atio_queue_update(qlt);
+
+		if (qlt->qlt_mq_enabled) {
+			qi = (uint16_t)(risc_status >> 16);
+			qlt->mq_resp[0].mq_ndx_from_fw =
+			    (uint16_t)MQBAR_RD32(qlt,
+			    (qi * MQBAR_REG_OFFSET) + MQBAR_RESP_IN);
+			/* FIX THIS to be optional */
+			REG_WR32(qlt, REG_HCCR,
+			    HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
+		} else {
+			qi = 0;
+			REG_WR32(qlt, REG_HCCR,
+			    HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
+			qlt->mq_resp[qi].mq_ndx_from_fw = risc_status >> 16;
+			REG_WR32(qlt, REG_HCCR,
+			    HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
+		}
+		qlt_handle_resp_queue_update(qlt, qi);
+
+	} else if (intr_type == 0x14) {
+		/* MQ */
+		uint16_t qi = 0;
+
+		if ((qlt->qlt_83xx_chip) || (qlt->qlt_27xx_chip)) {
+			qlt->atio_ndx_from_fw =
+			    (uint16_t)MQBAR_RD32(qlt, MQBAR_ATIO_IN);
+		} else {
+			qi = (uint16_t)(risc_status >> 16);
+			qlt->atio_ndx_from_fw = (uint16_t)
+			    REG_RD32(qlt, REG_ATIO_IN_PTR);
+		}
+		qlt_handle_atio_queue_update(qlt);
+
+		qlt->mq_resp[qi].mq_ndx_from_fw =
+		    (uint16_t)MQBAR_RD32(qlt,
+		    (qi * MQBAR_REG_OFFSET) + MQBAR_RESP_IN);
+		qlt_handle_resp_queue_update(qlt, qi);
 		REG_WR32(qlt, REG_HCCR, HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
-		qlt->resp_ndx_from_fw = risc_status >> 16;
-		qlt_handle_resp_queue_update(qlt);
+
 	} else if (intr_type == 0x12) {
 		uint16_t code = (uint16_t)(risc_status >> 16);
 		uint16_t mbox1 = REG_RD16(qlt, REG_MBOX(1));
@@ -2677,11 +4378,15 @@
 		uint16_t mbox6 = REG_RD16(qlt, REG_MBOX(6));
 
 		REG_WR32(qlt, REG_HCCR, HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
-		stmf_trace(qlt->qlt_port_alias, "Async event %x mb1=%x mb2=%x,"
-		    " mb3=%x, mb5=%x, mb6=%x", code, mbox1, mbox2, mbox3,
+		EL(qlt, "Async event %x mb1=%x, mb2=%x, mb3=%x, mb4=%x, "
+		    "mb5=%x, mb6=%x\n", code, mbox1, mbox2, mbox3, mbox4,
 		    mbox5, mbox6);
-		EL(qlt, "Async event %x mb1=%x mb2=%x, mb3=%x, mb5=%x, mb6=%x",
-		    code, mbox1, mbox2, mbox3, mbox5, mbox6);
+		stmf_trace(qlt->qlt_port_alias, "Async event %x mb1=%x mb2=%x,"
+		    " mb3=%x, mb4=%x, mb5=%x, mb6=%x", code, mbox1, mbox2,
+		    mbox3, mbox4, mbox5, mbox6);
+		cmn_err(CE_NOTE, "!qlt(%d): Async event %x mb1=%x mb2=%x,"
+		    " mb3=%x, mb4=%x, mb5=%x, mb6=%x", qlt->instance, code,
+		    mbox1, mbox2, mbox3, mbox4, mbox5, mbox6);
 
 		if ((code == 0x8030) || (code == 0x8010) || (code == 0x8013)) {
 			if (qlt->qlt_link_up) {
@@ -2692,6 +4397,48 @@
 			qlt->qlt_link_up = 0;
 			fct_handle_event(qlt->qlt_port, FCT_EVENT_LINK_DOWN,
 			    0, 0);
+		} else if (code == 0x8014) {
+			if (mbox1 == 0xffff) { /* global event */
+				uint8_t reason_code;
+
+				reason_code = (uint8_t)(mbox3 >> 8);
+
+				switch (reason_code) {
+				case 0x1d: /* FIP Clear Virtual Link received */
+				case 0x1a: /* received FLOGO */
+				case 0x1c: /* FCF configuration changed */
+				case 0x1e: /* FKA timeout */
+					if (mbox2 == 7) {
+						qlt->qlt_link_up = 0;
+						fct_handle_event(qlt->qlt_port,
+						    FCT_EVENT_LINK_DOWN, 0, 0);
+					}
+					break;
+				case 0x12:
+					if (mbox2 == 4) {
+						qlt->qlt_link_up = 1;
+						fct_handle_event(qlt->qlt_port,
+						    FCT_EVENT_LINK_UP, 0, 0);
+						stmf_trace(qlt->qlt_port_alias,
+						    "SNS login and SCR done");
+					}
+					break;
+				case 0:
+					if ((mbox2 == 6) &&
+					    (!qlt->qlt_link_up)) {
+						qlt->qlt_link_up = 1;
+						fct_handle_event(qlt->qlt_port,
+						    FCT_EVENT_LINK_UP, 0, 0);
+						stmf_trace(qlt->qlt_port_alias,
+						    "Link reinitialised");
+					}
+					break;
+				default:
+					stmf_trace(qlt->qlt_port_alias,
+					    "AEN ignored");
+					break;
+				}
+			}
 		} else if (code == 0x8011) {
 			switch (mbox1) {
 			case 0: qlt->link_speed = PORT_SPEED_1G;
@@ -2702,6 +4449,10 @@
 				break;
 			case 4: qlt->link_speed = PORT_SPEED_8G;
 				break;
+			case 5: qlt->link_speed = PORT_SPEED_16G;
+				break;
+			case 6: qlt->link_speed = PORT_SPEED_32G;
+				break;
 			case 0x13: qlt->link_speed = PORT_SPEED_10G;
 				break;
 			default:
@@ -2712,14 +4463,15 @@
 			    0, 0);
 		} else if ((code == 0x8002) || (code == 0x8003) ||
 		    (code == 0x8004) || (code == 0x8005)) {
-			(void) snprintf(info, sizeof (info),
+			(void) snprintf(info, 80,
 			    "Got %04x, mb1=%x mb2=%x mb5=%x mb6=%x",
 			    code, mbox1, mbox2, mbox5, mbox6);
+			info[79] = 0;
 			(void) fct_port_shutdown(qlt->qlt_port,
 			    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET |
 			    STMF_RFLAG_COLLECT_DEBUG_DUMP, info);
 		} else if (code == 0x800F) {
-			(void) snprintf(info, sizeof (info),
+			(void) snprintf(info, 80,
 			    "Got 800F, mb1=%x mb2=%x mb3=%x",
 			    mbox1, mbox2, mbox3);
 
@@ -2728,9 +4480,10 @@
 				qlt_verify_fw(qlt);
 			}
 		} else if (code == 0x8101) {
-			(void) snprintf(info, sizeof (info),
+			(void) snprintf(info, 80,
 			    "IDC Req Rcvd:%04x, mb1=%x mb2=%x mb3=%x",
 			    code, mbox1, mbox2, mbox3);
+			info[79] = 0;
 
 			/* check if "ACK" is required (timeout != 0) */
 			if (mbox1 & 0x0f00) {
@@ -2738,10 +4491,10 @@
 
 				/*
 				 * Ack the request (queue work to do it?)
-				 * using a mailbox iocb
+				 * using a mailbox iocb (only Queue 0 allowed)
 				 */
-				mutex_enter(&qlt->req_lock);
-				req = qlt_get_req_entries(qlt, 1);
+				mutex_enter(&qlt->mq_req[0].mq_lock);
+				req = qlt_get_req_entries(qlt, 1, 0);
 				if (req) {
 					bzero(req, IOCB_SIZE);
 					req[0] = 0x39; req[1] = 1;
@@ -2752,12 +4505,13 @@
 					QMEM_WR16(qlt, req+16, mbox4);
 					QMEM_WR16(qlt, req+18, mbox5);
 					QMEM_WR16(qlt, req+20, mbox6);
-					qlt_submit_req_entries(qlt, 1);
+					qlt_submit_req_entries(qlt, 1, 0);
 				} else {
-					(void) snprintf(info, sizeof (info),
+					(void) snprintf(info, 80,
 					    "IDC ACK failed");
+					info[79] = 0;
 				}
-				mutex_exit(&qlt->req_lock);
+				mutex_exit(&qlt->mq_req[0].mq_lock);
 			}
 		}
 	} else if ((intr_type == 0x10) || (intr_type == 0x11)) {
@@ -2783,19 +4537,27 @@
 	} else {
 		cmn_err(CE_WARN, "qlt(%d): Unknown intr type 0x%x",
 		    qlt->instance, intr_type);
+		stmf_trace(qlt->qlt_port_alias,
+		    "%s: Unknown intr type 0x%x [%x]",
+		    __func__, intr_type, risc_status);
 		REG_WR32(qlt, REG_HCCR, HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
 	}
 
-	(void) REG_RD32(qlt, REG_HCCR);	/* PCI Posting */
-	risc_status = REG_RD32(qlt, REG_RISC_STATUS);
-	if ((risc_status & BIT_15) &&
-	    (++intr_loop_count < QLT_MAX_ITERATIONS_PER_INTR)) {
-		goto intr_again;
+	(void) REG_RD32(qlt, REG_HCCR); /* PCI Posting */
+
+	if ((qlt->intr_flags & QLT_INTR_MSIX) == 0) {
+		risc_status = REG_RD32(qlt, REG_RISC_STATUS);
+		if ((risc_status & BIT_15) &&
+		    (++intr_loop_count < QLT_MAX_ITERATIONS_PER_INTR)) {
+			goto intr_again;
+		}
+		REG_WR32(qlt, REG_INTR_CTRL, ENABLE_RISC_INTR);
+		mutex_exit(&qlt->intr_lock);
+	} else {
+		mutex_exit(&qlt->intr_lock);
+		REG_WR32(qlt, REG_INTR_CTRL, ENABLE_RISC_INTR);
 	}
 
-	REG_WR32(qlt, REG_INTR_CTRL, ENABLE_RISC_INTR);
-
-	mutex_exit(&qlt->intr_lock);
 	return (DDI_INTR_CLAIMED);
 }
 
